// Copyright (c) 2023, Tencent Inc.
// All rights reserved.
#pragma once

#include <stddef.h>
#include <stdint.h>

#include "wmpf/types.h"

WX_BEGIN_DECLS

/**
 * @brief 设备抽象类
 *
 */
typedef struct wx_device {
  /**
   * @brief 当前设备的版本号
   *
   * 如果你实现的设备类需要进行破坏性更新，你就需要更新版本号.
   */
  struct wx_struct common;

  void* priv;

  void (*close)(struct wx_device* device);

} wx_device_t;

WX_END_DECLS
