// Copyright (c) 2023, Tencent Inc.
// All rights reserved.
#pragma once

#include <stddef.h>
#include <stdint.h>

#define WX_API __attribute__((visibility("default")))

#ifdef __cplusplus
#define WX_BEGIN_DECLS extern "C" {
#define WX_END_DECLS }
#else
#define WX_BEGIN_DECLS
#define WX_END_DECLS
#endif

// Annotate a typedef or function indicating it's ok if it's not used.
// Use like:
//   typedef Foo Bar WX_ALLOW_UNUSED_TYPE;
#if defined(COMPILER_GCC) || defined(__clang__)
#define WX_ALLOW_UNUSED_TYPE __attribute__((unused))
#else
#define WX_ALLOW_UNUSED_TYPE
#endif

#define wx_container_of(ptr, type, member) \
  ((type*)((char*)(ptr)-offsetof(type, member)))
