// Copyright (c) 2023, Tencent Inc.
// All rights reserved.
#include "./module.h"

namespace wx {

class Metadata {
 public:
  virtual ~Metadata() = default;

  virtual wx_error GetParameter(
      uint32_t key,
      struct wx_metadata_entry* value_out) const = 0;

  virtual wx_error SetParameter(uint32_t key,
                                  const struct wx_metadata_entry* value) = 0;

  static wx_error GetParameter(const wx_metadata_t* dev,
                                 uint32_t key,
                                 struct wx_metadata_entry* value_out) {
    return static_cast<const Metadata*>(dev->priv)->GetParameter(key,
                                                                 value_out);
  }

  static wx_error SetParameter(wx_metadata_t* dev,
                                 uint32_t key,
                                 const struct wx_metadata_entry* value) {
    return static_cast<Metadata*>(dev->priv)->SetParameter(key, value);
  }
};

}  // namespace wx
